/*
 * callback.c
 *
 * Copyright (C) 1993-1997, John Kilburg <john@cs.unlv.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>
#include <signal.h>

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "TextField.h"

#include "WWW.h"
#include "resources.h"

extern AppResources appr;

/*
 * MessageCallback
 */
bool
MessageCallback(closure, cbdata)
void *closure;
char *cbdata;
{
  CHead *h = (CHead *)closure;

  if (cbdata == NULL) cbdata = "";
  TextFieldSetString(h->message, cbdata);

  return(false);
}

/*
 * RedrawCallback
 */
bool
RedrawCallback(closure)
void *closure;
{
  CHead *h = (CHead *)closure;
  HeadRedraw(h);
  return(false);
}

/*
 * ResizeCallback
 */
bool
ResizeCallback(closure)
void *closure;
{
  CHead *h = (CHead *)closure;
  HeadRedraw(h);
  return(false);
}

/*
 * ActionCallback
 */
bool
ActionCallback(closure, ai)
void *closure;
WWWRenderActionInfo *ai;
{
  CHead *h = (CHead *)closure;

  if (ai == NULL || ai->wr == NULL)
  {
    TextFieldSetString(h->message, "Invalid URL.");
    return(false);
  }

  if (ai->type == NULL) return(false);
  if (strcmp(ai->type, "display") == 0) HeadOpen(h, ai->wr);
  else if (strcmp(ai->type, "download") == 0) DownloadOpen(ai->wr);

  return(false);
}
