/*
 * action.c
 *
 * Copyright (c) 1995-1997, John Kilburg <john@cs.unlv.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include "WWWP.h"

static WWWDisplay WWWPGetDisplay _ArgProto((Widget));

static WWWDisplay
WWWPGetDisplay(w)
Widget w;
{
  WWWWidget rw = (WWWWidget)XtParent(XtParent(w));
  return(rw->www.wd);
}

/*
 * WWWExposeAction
 */
void
WWWExposeAction(w, xe, params, num_params)
Widget w;
XEvent *xe;
String *params;         /* unused */
Cardinal *num_params;   /* unused */
{
  WWWDisplay wd = WWWPGetDisplay(w);

  if (wd == NULL) return;

  WWWExposeDisplay(wd, xe->xexpose.x, xe->xexpose.y,
		   xe->xexpose.width, xe->xexpose.height);

  return;
}


/*
 * WWWSelectAction
 */
void
WWWSelectAction(w, xe, params, num_params)
Widget w;
XEvent *xe;
String *params;         /* unused */
Cardinal *num_params;   /* unused */
{
  WWWDisplay wd = WWWPGetDisplay(w);

  if (wd == NULL) return;

  WWWSelectDisplay(wd, xe->xbutton.x, xe->xbutton.y, xe->xbutton.button);

  return;
}

/*
 * WWWMotionAction
 */
void
WWWMotionAction(w, xe, params, num_params)
Widget w;
XEvent *xe;
String *params;         /* unused */
Cardinal *num_params;   /* unused */
{
  WWWDisplay wd = WWWPGetDisplay(w);

  if (wd == NULL) return;

  WWWMotionDisplay(wd, xe->xmotion.x, xe->xmotion.y, -1);
  
  return;
}
